-- This DOS program call another DOS program passing customized parameter 
-- block included modified set of environment variables, uses low level 
-- DOS functions without make a call to command.com or system()
-- Marco Antonio Achury 2008


include machine.e

sequence my_env  -- User customized environment table
sequence tail   -- Command line optional parameter passed e.g. "/help"


-- Call DOS Int 21h Function 4B00  Load and execute a program
procedure load_exec(sequence child_program_name, sequence tail, sequence my_env)
    integer env_add  -- Memory address to poke environment table
    integer tail_add  -- Memory adress to save user parameters
    integer load_add  -- Memory address to build LOADEXEC DOS struct 
    integer FCB1  -- Memory address to empty FCB's
    integer FCB2
    integer child_add --Memory address to allocate child_program_filename
    sequence regs  -- CPU registers
    sequence empty_FCB --Empty FCB, 2 FCB fields are used by DOS 2.0 and early
		   --Later DOS requires an empty FCB field for back 
		   --compatibility
    empty_FCB = repeat (' ',11) & repeat(0,5)  -- Empty filename and address
    FCB1 = allocate_low(16)
    FCB2 = allocate_low(16)


    --Allocate environment table
    env_add = allocate_low(length(my_env))
    poke (env_add, my_env)
    
    --Allocate tail parameters 
    tail_add = allocate_low(length(tail))
    poke (tail_add, tail)
    
    
    -- Create customized LOADEXEC struct
    load_add = allocate_low (28) --allocate space
	poke4 (load_add, {
	floor(env_add / 16),        --Environment table segment
	floor(tail_add / 16),       --Tail segment
	remainder(tail_add, 16),    -- Tail offset
	floor(tail_add / 16),       --FCB1 segment
	remainder(tail_add, 16),    -- FCB1 offset
	floor(tail_add / 16),       -- FCB2 segment
	remainder(tail_add, 16)     -- FCB2 offset
    }) 
    
    child_add = allocate_low(100)   --May be enougth to allocate filename
				    --with or without fullpath?
    poke (child_add, child_program_name & {0})
    
    regs = repeat(0,10)
    
    regs[REG_DS] = floor(child_add/16)
    regs[REG_DX] = remainder(child_add, 16)
    regs[REG_ES] = floor(load_add/16)
    regs[REG_BX] = remainder(load_add, 16)
    regs[REG_AX] = #4B00
    
    regs = dos_interrupt(#21, regs)
    
end procedure
    
    
    
--Create customized environment table
--Each entry must to end with 0, the table must to end with another 0
--TO DO: better if the sequence have not zeros, anf they are added by loadexec
my_env = "PATH=C:\\EUPHORIA\\BIN" & {0} & "MYVAR=MYVALUE" & {0} & {0}
tail = " C:\\EUPHORIA\\EXELOAD\\TEST.EX" & {0}

puts(1,"\n")
--? tail
--?my_env
puts(1,"\n")

puts (1, "\nBefore call\n")
load_exec("C:\\EUPHORIA\\BIN\\EX.EXE" & {0}, tail, my_env)
puts (1, "\nAfter call\n")

